#!/bin/sh

FLOWEYE=/usr/ramdisk/bin/floweye
WEB_LOGGER()
{
        local logfile
        local curtime

        localfile="${DATAPATH}/web_`date +%Y.%m.%d`.log"
        curtime=`date +%Y.%m.%d/%H:%M:%S`
        echo "${curtime} ${REMOTE_ADDR} ${CGI_username} $1 $2" >> ${localfile}
}

printf "Content-type: text/html\r\n";
printf "Cache-Control: no-cache\r\n"

# cookie ip user logintime 
if [ "${REQUEST_METHOD}" = "POST" ]; then
	. /etc/PG.conf

	# Check username and password
	success=0
	for line in `cat ${PGPATH}/admin/.htpasswd`
	do
		if [ "${line}" = "${CGI_username}:${CGI_password}" ]; then
			success=1
			break
		fi
	done

	if [ ${success} -eq 1 ]; then
		logintime=`date +%s1`
		mkdir -p /usr/ramdisk/weblogin/
		cookieinfo="palogin_${CGI_username}_$$_${logintime}"
		cookiefile="/usr/ramdisk/weblogin/${cookieinfo}"
		echo "ip=${REMOTE_ADDR}" > ${cookiefile}
		echo "user=${CGI_username}" >> ${cookiefile}
		echo "logintime=`date +%Y.%m.%d/%H:%M:%S`" >> ${cookiefile}
		printf "Set-Cookie: pauser=${CGI_username},${cookieinfo};Path=/;\r\n"
		printf "\r\n"

		WEB_LOGGER "û¼" "user=${CGI_username},ip=${REMOTE_ADDR}"
		errmsg=`${FLOWEYE} logger alert "${CGI_username} login success from ${REMOTE_ADDR}"`

		echo "<html xmlns:v=\"urn:schemas-microsoft-com:vml\" xmlns:o=\"urn:schemas-microsoft-com:office:office\">"
		echo "<head>"
		echo "<meta http-equiv=\"Content-Type\" content=\"text/html; charset=gb2312\">"
		echo "<META HTTP-EQUIV=REFRESH CONTENT=\"0;URL=/index.htm\">"
		echo "</head>"
		echo "</html>"
	else
		errmsg=`${FLOWEYE} logger alert "${CGI_username} login FAIL from ${REMOTE_ADDR}"`
		printf "\r\n"
		echo "<html xmlns:v=\"urn:schemas-microsoft-com:vml\" xmlns:o=\"urn:schemas-microsoft-com:office:office\">"
		echo "<head>"
		echo "<script language=javascript>"
		echo "alert(\"û벻!\");"
		echo "</script>"
		echo "<meta http-equiv=\"Content-Type\" content=\"text/html; charset=gb2312\">"
		echo "<META HTTP-EQUIV=REFRESH CONTENT=\"0;URL=/login/login.htm\">"
		echo "</head>"
		echo "</html>"
	fi
else
	printf "\r\n"
	echo "<html xmlns:v=\"urn:schemas-microsoft-com:vml\" xmlns:o=\"urn:schemas-microsoft-com:office:office\">"
	echo "<head>"
	echo "<meta http-equiv=\"Content-Type\" content=\"text/html; charset=gb2312\">"
	echo "<META HTTP-EQUIV=REFRESH CONTENT=\"0;URL=/login/index.htm\">"
	echo "</head>"
	echo "</html>"
fi
